﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CVB_TEST_ZOOM
{
    /// <summary>
    /// Logique d'interaction pour MainWindow.xaml
    /// </summary>
    
    public partial class MainWindow : Window
    {
        double zoominit = 0;
        System.Windows.Threading.DispatcherTimer DispatcherTimerZoom;
        public MainWindow()
        {
            InitializeComponent();
            DispatcherTimerZoom = new System.Windows.Threading.DispatcherTimer();
            DispatcherTimerZoom.Tick += new EventHandler(DispatcherTimerZoom_Tick);
            DispatcherTimerZoom.Interval = new TimeSpan(0, 0, 0, 0, 100);
            
        }

        private void DispatcherTimerZoom_Tick(object sender, EventArgs e)
        {
            DispatcherTimerZoom.Stop();
            zoominit = disp_img.ActualZoomFactor;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Microsoft.Win32.OpenFileDialog openFileDialog = new Microsoft.Win32.OpenFileDialog();
                Nullable<bool> result = openFileDialog.ShowDialog();
                if (result==true)
                {
                    disp_img.Image = Stemmer.Cvb.Image.FromFile(openFileDialog.FileName);

                    DispatcherTimerZoom.Start();
                }
            }
            catch (Exception)
            { }
        }

        private void Disp_img_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            Point t = Mouse.GetPosition(disp_img);

            double x = (t.X - disp_img.ImageViewportHorizontalOffset) / disp_img.ActualZoomFactor;
            double y = (t.Y - disp_img.ImageViewportVerticalOffset) / disp_img.ActualZoomFactor;

            if (disp_img.ActualZoomFactor != zoominit) disp_img.ZoomFactor = zoominit;
            else
            {
                disp_img.ZoomFactor = zoominit * 2;
                disp_img.ZoomCenter = new System.Windows.Point(x, y);
            }
        }
    }
}
